<?php
/*--------------------------------------------+
| GameStatusViewer     V 1.0     2005-07-26   |
| Game Americas Army                          |
|---------------------------------------------|
| Copyright Makro (Markus Kronier)  2005     |
| web: http://www.makromobil.de               |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

class CGame_AAO {
  //---------------
  var $m_serverIp;
  var $m_queryPort;
  var $m_requestCmd  = array();
  //---------------

  var $m_serverData;
  var $gameName      = "Americas Army";
  var $gameImagePath = "images/aao/";
  var $gameImage     = 'default';
  var $gameStatusImage = array();
  var $gameData      = array();
  var $playerData    = array();

  function CGame_AAO($serverIp, $queryPort) {
    $this->m_serverIp     = $serverIp;
    $this->m_queryPort    = $queryPort;
    $this->m_requestCmd   = "\xFE\xFD\x00GS2\x00\xFF\xFF\x00";
  }

  function PrepareGameData($gameData) {
    $this->gameData   = array();

    //--- Hostname
    if ($gameData['hostname'] != "") {
      $this->gameData['Servername'] = $gameData['hostname'];
    }
    //--- Hostip/Port
    if ($gameData['hostip'] != "") {
      $this->gameData['ServerIP'] = $gameData['hostip'].":".$gameData['hostport'];
    }
    //--- Gametype
    if ($gameData['gametype'] != "") {
      $this->gameData['Gametype'] = $gameData['gametype'];
    }
    //--- Official/leased
    if (($gameData['official'] != "") && ($gameData['leased']!="")) {
      $this->gameData['Official-Leased'] = "(".$gameData['official']."/".$gameData['leased'].")";
    }
    //--- Map
    if ($gameData['mapname'] != ""){
      $this->gameData['Map'] = $gameData['mapname'];
      $this->gameImage = strtolower(str_replace(' ','_', $gameData['mapname']));
    }
    //--- Honor (min/max)
    if (($gameData['minhonor'] !="0") || ($gameData['maxhonor'] != "")) {
      $this->gameData['Honor (min/max)'] = "(".$gameData['minhonor']."/".$gameData['maxhonor'].")";
    }
    //--- Players
    if (($gameData['numplayers'] != "") || ($gameData['maxplayers'] != "")) {
      $this->gameData['Players'] = "(".$gameData['numplayers']."/".$gameData['maxplayers'].")";
    }
    //--- Round/ MissionTime
    if ($gameData['current_round'] != "") {
      $this->gameData['Round'] = $gameData['current_round'];
    }
    if ($gameData['mission_time'] != "") {
      $this->gameData['Time'] = $gameData['mission_time'];
    }
    //--- Statusimages
    $this->gameStatusImage = array();
    $this->gameStatusImage[] = "livefire";
    if ($gameData['password'] == "1") $this->gameStatusImage[] = "password";
    if ($gameData['sv_punkbuster'] =="1") $this->gameStatusImage[] = "punkbuster";
    if ($gameData['miles'] =="1") $this->gameStatusImage[] = "miles";

    //---
    $corrFields = array("Servername","Map");
    foreach ($corrFields as $Key) {
      $this->gameData[$Key]= htmlspecialchars($this->gameData[$Key]);
      $this->gameData[$Key]= preg_replace("/[^(\x20-\x7E)]/","",$this->gameData[$Key]);
      $this->gameData[$Key]= preg_replace("/\^[0-9]/","",$this->gameData[$Key]);
      
    }
    //--- Queryport
    //if ($gameData['queryport']) $this->gameData['QueryPort'] = $gameData['queryport'];
  }

  function PreparePlayerData($playerData) {
    $this->playerData = array();
    $playerHeader     = array("Player"=>"player_","Honor"=>"honor_","Kills"=>"enemy_","KIA"=>"kia_", "Leader"=>"leader_", "Goals"=>"goal_","ROE"=>"roe_","Ping"=>"ping_");

    $playerIdx = 1;
    while ($playerData['player_'.$playerIdx] != "") {
      $player = array();
      $player["Id"] = $playerIdx ;
      foreach ($playerHeader as $Key => $attr) {
        $player[$Key] = $playerData[$attr.$playerIdx];
      }
      $player["Player"] = htmlspecialchars($player["Player"]);
      $player["Player"] = preg_replace("/\^[0-9]/","",$player["Player"]);
      $this->playerData[] = $player;
      $playerIdx++;
    }
  }

  function PrepareData() {
    $gameData     = array();
    $playerData   = array();
    $playerHeader = array();

    $gameData["hostip"]    = $this->m_serverIp;
    $gameData["queryport"] = $this->m_queryPort;

    $data      = explode("\x00", $this->m_serverData);
    if (count($data) > 2) {
      if ($data[1] == "GS2") {
        $i = 2;
        while ($data[$i] != "") {
          $gameData[$data[$i]]= $data[$i+1];
          $i+= 2;
        }
        $i+=2;
        while ($data[$i] != "") {
          $playerHeader[] = preg_replace("/^[^0-9a-zA-Z](.*)/",'$1',$data[$i]);
          $i++;
        }
        $i++;
        $m = 0;
        $pl= 1;
        while ($data[$i] != "") {
          $playerData[$playerHeader[$m].$pl] = $data[$i];
          $i++;
          $m++;
          if ($m == count($playerHeader)) {
            $m = 0;
            $pl++;
          }
        }
      }
    }
    $this->PrepareGameData($gameData);
    $this->PreparePlayerData($playerData);
  }

  function ReadServerData() {
    $error = "";
    $this->m_serverData = '';

    $socket = @fsockopen('udp://'. $this->m_serverIp, $this->m_queryPort, $errno, $errstr, 10);
    if ($socket) {
      socket_set_timeout($socket, 1);

      //--- Send request to Server
      fwrite($socket, $this->m_requestCmd);

      //--- Read response
      $this->m_serverData = fread($socket, 8192);

      fclose($socket);
    } else {
      $error = "not connected to the server!";
    }
    $this->PrepareData();
    return $error;
  }
}

?>